package RTC;


/**
* RTC/FsmParticipantActionOperations.java .
* IDL-to-Java \u30b3\u30f3\u30d1\u30a4\u30e9 (\u30dd\u30fc\u30bf\u30d6\u30eb), \u30d0\u30fc\u30b8\u30e7\u30f3 "3.1" \u3067\u751f\u6210
* \u751f\u6210\u5143: idl/LogicalTimeTriggeredEC.idl
* 2015\u5e743\u670820\u65e5 14\u664235\u520651\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief FsmParticipantAction
   *
   * @section Description
   *
   * FsmParticipantAction is companion to ComponentAction (see Section
   * 5.2.2.4) that is intended for use with FSM participant RTCs. It
   * adds a callback for the interception of state transitions, state
   * entries, and state exits.
   *
   * @endif
   */
public interface FsmParticipantActionOperations 
{

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_action
       *
       * @section Description
       *
       * The indicated FSM participant RTC has been invoked as a result
       * of a transition, state entry, or state exit in its containing
       * FSM.
       *
       * @section Constraints
       *
       * - The given execution context shall be of kind EVENT_DRIVEN.
          *
       * @endif
       */
  RTC.ReturnCode_t on_action (int exec_handle);
} // interface FsmParticipantActionOperations
